package samples.oo.classes;

/*
    A standalone Java class in its own file
    Using access (private/public) to hide/expose instance variables and methods

 */
public class Player {     // Class and filename must be same

    private final String name;       // No one outside this file can access
    private int points;

    public Player(String name, int points) {
        this.name = name;
        this.points = points;
    }

    public Player(String name) {
        this(name, 0);        // this() is constructor
    }

    public String getName() {
        return name;      // Same as this.name
    }

    @Override
    public String toString() {
        return "Player{" +
                "name='" + name + '\'' +
                ", points=" + points +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Player player = (Player) o;
        return name.equals(player.name);
    }

    @Override
    public int hashCode() {
        return name != null ? name.hashCode() : 0;
    }
}


