package samples.oo.inheritancetypes;

import static java.lang.System.out;

/*
 *  Inheritance and types (type compatibility)
 */
public class TestInheritanceTypes {

    public static void main(String[] args) {
        new TestInheritanceTypes().program();
    }

    void program() {

        Dog d = new Dog("Fido", 3);
        Cat c = new Cat("Missan",4, false);

        Animal a1 = d;  // Ok type of object d is subtype to Animal
        Animal a2 = c;

        //d = (Dog) a2;   // Compiles but exception later
        d = (Dog) a1;     // Ok
        //c = (Cat) a1;   // Compiles but exception later

        //d = c;          No never!
        //c = d;
        //d = (Dog) c;    No never!
        //c = (Cat) d;

        ISayable s1 = d;   // Ok
        ISayable s2 = c;

        d = (Dog) s1;    // Ok
        c = (Cat) s2;    // Ok

        Car car1 = new Car();
        ISayable s3 = (ISayable) car1;    // Why allowed .... (is always allowed)???

        car1= new TalkingCar();
        ISayable s4 = (ISayable) car1;     // ... because sub class may implement!
        out.println(s4.say());
    }



}
