

import java.util.Arrays;
import java.util.Random;
import java.util.Scanner;

import static java.lang.System.*;

/*
 *  This is the LCD game
 *  See: https://en.wikipedia.org/wiki/LCR_(dice_game)
 */
public class LCRGame {

    public static void main(String[] args) {
        new LCRGame().program();
    }

    final Scanner sc = new Scanner(in);  // The only allowed variables outside methods.
    final Random rand = new Random();

    void program() {
        //test();        // < -------------------- Uncomment to run tests

        boolean aborted = false;            // Game aborted?

        gameStartMsg();
        //Player[] players = ...;
        //Player actual = ...;
        //statusMsg(players);

        // TODO Main game loop here


        //gameOverMsg(players, aborted);
    }

    // ---- Logical methods -----------------



    int rollDice() {
        return rand.nextInt(6) + 1;
    }

    // --- IO Methods -----------------------------------------

    void gameStartMsg() {
        out.println("LCR Game started");
        out.println("r = roll, q = quit");
    }

    Player[] getPlayers() {
        out.print("How many chips per player? > ");
        int nChips = sc.nextInt();
        out.print("How many players? > ");
        int nPlayers = sc.nextInt();
        sc.nextLine();  // Read away \n
        Player[] players = new Player[nPlayers];

        // TODO

        return players;
    }

    void gameOverMsg(Player[] players, boolean aborted) {
        if (aborted) {
            out.println("Aborted");
        } else {
            int i = 0;
            while (players[i].nChips == 0) {
                i++;
            }
            out.println("Game over! Winner is " + players[i].name);
        }
    }

    void roundMsg(String[] result) {
        out.println(Arrays.toString(result));
    }

    void statusMsg(Player[] players) {
        out.print("Status: ");
        for (Player p : players) {
            out.print(p.name + ": " + p.nChips + " ");
        }
        out.println();
    }

    String getCommand(Player actual) {
        out.print("Player is " + actual.name + " > ");
        return sc.nextLine();
    }

    // ------- Class to hold player data -----------

    class Player {     // This makes it simpler to handle player data
        String name;
        int nChips;
    }

    //---------------- Testing ------------------------------

    // To test we create (and print out) an expression that should be true!
    // Tests should always be kept! Even if program finished. It's part of documentation
    void test() {

        // Test the dice
        int d = rollDice();
        out.println(1 <= d && d <= 6);   // Should print "true"
        d = rollDice();
        out.println(1 <= d && d <= 6);

        // TODO


        exit(0);  // Will terminate program, *NEVER* use except here!
    }
}
