package exercises;

import java.util.Random;
import java.util.Scanner;

import static java.lang.System.exit;
import static java.lang.System.in;
import static java.lang.System.out;

/*
 *  The TicTacToe Game
 *  See https://en.wikipedia.org/wiki/Tic-tac-toe.
 *
 *  This is exercising functional decomposition
 *
 *  NOTE: Just use an array for the board (we print it to look square)
 *
 */
public class Ex10TicTacToe {

    public static void main(String[] args) {
        new Ex10TicTacToe().program();
    }

    final Scanner sc = new Scanner(in);
    final Random rand = new Random();
    final char EMPTY = '-';

    void program() {
        //test();       // <--------- Comment out to test

        Player p1 = getPlayer("olle", 'X');
        Player p2 = getPlayer("fia", 'O');
        Player actual;
        Player winner = null;
        char[] board = createBoard();  // alt. { EMPTY, EMPTY, ... }

        out.println("Welcome to Tic Tac Toe, board is ...");
        plotBoard(board);

        if (rand.nextBoolean()) {
            actual = p1;
        } else {
            actual = p2;
        }


        // TODO Program loop here

        if (winner != null) {
            out.println("Winner is " + actual.name);
        } else {
            out.println("Draw");
        }
    }

    // ---------- Logic methods ----------------

    char[] createBoard() {
        char[] board = new char[9];
        for (int i = 0; i < board.length; i++) {
            board[i] = EMPTY;
        }
        return board;
    }

    // ---------- IO methods ------------------

    int getPlayerSelection(Player player) {
        int selection;
        while (true) {
            out.println("Player is " + player.name + "(" + player.mark + ")");
            out.print("Select position to put mark (0-8) > ");
            selection = sc.nextInt();
            if (0 <= selection && selection <= 8) {
                break;
            }
            out.println("Bad choice (0-8 allowed)");
        }
        return selection;
    }

    void plotBoard(char[] board) {
        for (int i = 0; i < board.length; i++) {
            out.print(board[i] + " ");
            if ((i + 1) % 3 == 0) {
                out.println();
            }
        }
    }

    Player getPlayer(String name, char mark) {
        Player p = new Player();
        p.name = name;
        p.mark = mark;
        return p;
    }

    // -----  A class (blueprint) for players ---------
    class Player {
        String name;
        char mark;
    }

    // --------- Tests ------------------

    void test() {
        char[] testBoard1 = {'X', 'X', 'X', '0', 'O', 'X', 'O', '0', 'O'};

        // Test logic methods here


        exit(0);
    }
}