package exercises.ex4hangman;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.List;

/*
 * File handling for Hangman
 *
 * Used to read file word.txt containing words to guess.
 *
 * This doesn't represent some concept, it's just pure functionality, like Math class
 * so use static
 *
 *     *** Nothing to do here ***
 */
public class FileService {

    public static List<String> readFile(Path path) throws IOException {
        List<String> lines = new ArrayList<>();
        // Use try with resources to ensure stream is closed
        try (BufferedReader reader = Files.newBufferedReader(path)) {
            String line;
            while ((line = reader.readLine()) != null) {
                if( line.length() > 0) {
                    lines.add(line);
                }
            }
            reader.close();
            return lines;
        }

    }

}
