package exercises.ex4hangman;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

import static java.lang.System.*;

/*
 *  The very well known Hangman game (in a text version)
 *  This is the main program i.e. game logic and the text based IO.
 *
 *  Run this to run the game
 *
 */
public class HangMan {

    public static void main(String[] args) {
        new HangMan().program();
    }

    private final Scanner sc = new Scanner(in);
    private final Random rand = new Random();

    // Parts of the hanging man (\n is the new line character)
    private final String[] parts = {
            "---|\n",
            "   |\n",
            "   O\n",
            "  /",
            "|",
            "\\\n",   // This is \\ (2 backslash) and a new line (= escaping), see web
            "  /",
            " \\\n",
    };

    private int nGuess = 0;
    private Result result;

    private void program() {
        List<String> words;
        try {
            Path path = Paths.get("src/exercises/ex4hangman/words.txt");
            words = FileService.readFile(path);
        } catch (IOException e) {
            out.println(e.getMessage());
            return;
        }


        String theWord  = words.get(rand.nextInt(words.size()));
        out.println(theWord);

        // TODO Create a man and a secret

        out.println("Welcome to HangMan, try to guess the word! It's "
                + theWord.length() + " char long");

        while (true) {
            char ch = guessCharacter();


            // TODO


            nGuess++;
            //plotMan( TODO );
            out.println();  // Layout
            //plotMask( TODO );


        }
        //plotMan( TODO);
        //plotMask(TODO );

        /*
        if (result == Result.WIN) {
            out.println("You made it. You needed " + nGuess + " tries");
        } else {
            out.println("Sorry you lost. Word(s) was: " + TODO);
        }*/

    }

    // ---- IO don't belong to model subclasses, put it here ---------------
    private char guessCharacter() {
        String input;
        while( true ){
            out.print("Enter a char > ");
            input = sc.nextLine();
            if( input.length() == 1 && Character.isLetter(input.charAt(0))){
                break;
            }
        }
        return input.charAt(0);
    }

    private void plotMask(String mask) {
        for (char ch : mask.toCharArray()) {
            out.print(ch + " ");
        }
        out.println();
    }

    private void plotMan(int nParts) {
        for( int i = 0  ; i < nParts ; i++){
            out.print(parts[i]);
        }
    }
}
