package samples.catchtherain;

import javafx.scene.paint.Color;

/*
 *  A Single rain drop
 */
public class RainDrop {

    // Instance variables
    private final double x;     // Top left x and y for surrounding rectangle
    private double y;
    private double dy;    // Speed
    private final double radius;
    private final Color color;  // Must remember color

    public RainDrop(double x, double y, double radius, Color color) { // Constructor
        this.x = x;
        this.y = y;
        this.radius = radius;
        this.color = color;
    }

    public void move() {
        y += dy;
    }

    public void setSpeed(double dy) {
        this.dy = dy;
    }

    // ------ Collision detection and rendering --------

    public Color getColor() {
        return color;
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public double getMaxX() {
        return x + 2 * radius;
    }

}
