package samples.oo.collections;

/*
 *  Abstract base class (eliminating common code)
 */
public abstract class Animal implements ISayable {

    private String name;   // Both these in Cat and Dog
    private int age;

    public Animal(String name, int age) {
        this.name = name;
        this.age = age;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    @Override                       // Same method as in interface ISayable, so override
    public abstract String say();   // Not implemented here, must be implemented by sub classes
}
